Subject: Re: [PATCH] dir: force untracked cache with core.untrackedCache

From: Derrick Stolee <[email-masked]>
Date: Mon, 14 Feb 2022 15:40:26 -0500

On 2/14/2022 3:16 PM, Junio C Hamano wrote:
> "Derrick Stolee via GitGitGadget" <[email-masked]> writes:
> 
>> From: Derrick Stolee <[email-masked]>
>>
>> The GIT_FORCE_UNTRACKED_CACHE environment variable writes the untracked
>> cache more frequently than the core.untrackedCache config variable. This
>> is due to how read_directory() handles the creation of an untracked
>> cache. The old mechanism required using something like 'git update-index
>> --untracked-cache' before the index would actually contain an untracked
>> cache. This was noted as a performance problem on macOS in the past, and
>> this is a resolution for that issue.
> 
> "The old mechanism" meaning "core.untrackedCache does not add a new
> one; it only updates an existing one"?  What "this" refers to that
> was noted as a problem on macOS is not quite clear; is "writing
> untracked cache is a performance problem"? And the last "this" which
> is a resolution is "not to add untrackedCache merely because the
> configuration variable says we are allowed to use it"?

Right. I can see how that is confusing. Here's another attempt:

   The GIT_FORCE_UNTRACKED_CACHE environment variable writes the untracked
   cache more frequently than the core.untrackedCache config variable. This
   is due to how read_directory() handles the creation of an untracked
   cache.

   Before this change, Git would not create the untracked cache extension
   for an index that did not already have one. Users would need to run a
   command such as 'git update-index --untracked-cache' before the index
   would actually contain an untracked cache.

   In particular, users noticed that the untracked cache would not appear
   even with core.untrackedCache=true. Some users reported setting
   GIT_FORCE_UNTRACKED_CACHE=1 in their engineering system environment to
   ensure the untracked cache would be created.
 
>> The decision to not write the untracked cache without an environment
>> variable tracks back to fc9ecbeb9 (dir.c: don't flag the index as dirty
>> for changes to the untracked cache, 2018-02-05). The motivation of that
>> change is that writing the index is expensive, and if the untracked
>> cache is the only thing that needs to be written, then it is more
>> expensive than the benefit of the cache. However, this also means that
>> the untracked cache never gets populated, so the user who enabled it via
>> config does not actually get the extension until running 'git
>> update-index --untracked-cache' manually or using the environment
>> variable.
> 
> OK.  It was invented solely as a test mechanism it seems, but at
> least to the workflow of Microsoft folks, once we spent cycles to
> prepare UNTR data, it helps their future use of the index to spend
> a bit more cycle to write it out, instead of discarding.
> 
> I have to wonder if there are workflows that are sufficiently
> different from what Microsoft folks use that the write-out cost of
> more frequent updates to the untracked cache outweigh the runtime
> performance boost of not having to run around and readdir() for
> untracked files?

I think the only difference here is the transition state from no cache
to an existing cache. From then on, the cache is kept up-to-date with
the same frequency as without this change.

> ad0fb659 (repo-settings: parse core.untrackedCache, 2019-08-13)
> explains that unset core.untrackedCache means "keep", and "true"
> means untracked cache is "automatically added", which this change is
> not invalidated, so I guess there is no need to update anything in
> the documentation for this change.  In fact, we might be able to
> sell this change as a bugfix (i.e. "I set the configuration to
> 'true' but it wasn't written out when it should have").

Yes, I believe this to be the case. Hopefully the rewritten
paragraphs above make this more clear.

Thanks,
-Stolee